=== debian/changelog ===
librtr (0.6.3-1) unstable; urgency=medium

  * Import new upstream release
    - Fixes build issues with big endian architectures
  * Mark librtr-doc as Multi-Arch: foreign
  * Pass --as-needed to the linker to avoid useless dependencies

 -- Lukas Schwaighofer <lukas@schwaighofer.name>  Sun, 09 Dec 2018 14:04:06 +0100

librtr (0.6.0-1) unstable; urgency=medium

  * Initial release (Closes: #728206)

 -- Lukas Schwaighofer <lukas@schwaighofer.name>  Sat, 01 Dec 2018 22:43:01 +0100
