=== debian/control ===
Source: librtr
Section: libs
Priority: optional
Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
Uploaders: Lukas Schwaighofer <lukas@schwaighofer.name>
Build-Depends:
 cmake,
 debhelper (>= 11),
 doxygen,
 libssh-dev,
Standards-Version: 4.2.1
Homepage: https://rtrlib.realmv6.org/
Vcs-Browser: https://salsa.debian.org/pkg-security-team/librtr
Vcs-Git: https://salsa.debian.org/pkg-security-team/librtr.git

Package: librtr-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: librtr0 (= ${binary:Version}), ${misc:Depends}, libssh-dev
Suggests: librtr-doc
Description: Small extensible RPKI-RTR-Client C library - development files
 RTRlib is an open-source C implementation of the  RPKI/Router Protocol
 client. The library allows one to fetch and store validated prefix origin data
 from a RTR-cache and performs origin verification of prefixes. It supports
 different types of transport sessions (e.g., SSH, unprotected TCP) and is
 easily extendable.
 .
 This package contains development files.

Package: librtr-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Small extensible RPKI-RTR-Client C library - documentation
 RTRlib is an open-source C implementation of the  RPKI/Router Protocol
 client. The library allows one to fetch and store validated prefix origin data
 from a RTR-cache and performs origin verification of prefixes. It supports
 different types of transport sessions (e.g., SSH, unprotected TCP) and is
 easily extendable.
 .
 This package contains the doxygen generated HTML documentation for the
 libraries.

Package: librtr0
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Small extensible RPKI-RTR-Client C library
 RTRlib is an open-source C implementation of the  RPKI/Router Protocol
 client. The library allows one to fetch and store validated prefix origin data
 from a RTR-cache and performs origin verification of prefixes. It supports
 different types of transport sessions (e.g., SSH, unprotected TCP) and is
 easily extendable.

Package: rtr-tools
Section: utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: RPKI-RTR command line tools
 Contains tools provided with RTRlib.
 .
 rtrclient is command line that connects to an RPKI-RTR server and prints
 protocol information and information about the fetched ROAs.
 .
 rpki-rov is a command line tool that connects to an RPKI-RTR server and allows
 validating IP prefixes and origin ASes.
