## librtr 0.7.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,10 +7,22 @@
 set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/modules)
 set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -std=gnu99 -fstack-protector-all")
 if(CMAKE_BUILD_TYPE STREQUAL Debug)
-    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99 -Wall -Wextra -Wformat-security -Wmissing-prototypes -Wmissing-declarations -Wdeclaration-after-statement -Winit-self -Waggregate-return -Wmissing-format-attribute -Wundef -Wbad-function-cast -Wwrite-strings -Wformat=2")
+    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99 -Wall -Wextra -Wformat-security -Winit-self -Wundef -Wwrite-strings")
+    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wformat=2 -Werror=missing-prototypes -Werror=missing-declarations")
+    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wmissing-format-attribute -Werror=implicit-function-declaration")
+    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror=bad-function-cast -Werror=return-type")
+
     execute_process(COMMAND ${CMAKE_C_COMPILER} -dumpversion OUTPUT_VARIABLE GCC_VERSION)
     if(GCC_VERSION VERSION_GREATER 4.8 OR GCC_VERSION VERSION_EQUAL 4.8)
         set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wfree-nonheap-object")
+    endif()
+
+    if(GCC_VERSION VERSION_GREATER 5.1 OR GCC_VERSION VERSION_EQUAL 5.1)
+        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror=incompatible-pointer-types")
+    endif()
+
+    if(GCC_VERSION VERSION_GREATER 8.0 OR GCC_VERSION VERSION_EQUAL 8.0)
+        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror=cast-function-type")
     endif()
 
     set(DOCS_EXCLUDE_PATTERN "")
@@ -19,6 +31,8 @@
 endif(CMAKE_BUILD_TYPE STREQUAL Debug)
 
 include_directories(.)
+
+add_subdirectory(third-party)
 
 find_package(codecov)
 
@@ -33,20 +47,25 @@
     rtrlib/lib/ip.c rtrlib/lib/ipv4.c rtrlib/lib/ipv6.c rtrlib/lib/log.c
     rtrlib/pfx/trie/trie.c rtrlib/pfx/trie/trie-pfx.c rtrlib/transport/transport.c
     rtrlib/transport/tcp/tcp_transport.c rtrlib/rtr/rtr.c rtrlib/rtr/packets.c
-    rtrlib/spki/hashtable/ht-spkitable.c rtrlib/spki/hashtable/tommyds-1.8/tommy.c)
+    rtrlib/spki/hashtable/ht-spkitable.c ${tommyds})
 set(RTRLIB_LINK ${RT_LIB} ${CMAKE_THREAD_LIBS_INIT})
 
-find_package(LibSSH 0.5.0 QUIET)
-if(LIBSSH_FOUND AND NOT NOSSH)
-    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D LIBSSH_VERSION_MAJOR=${LibSSH_VERSION_MAJOR} -D LIBSSH_VERSION_MINOR=${LibSSH_VERSION_MINOR}")
-    set(RTRLIB_HAVE_LIBSSH 1)
-    include_directories(${LIBSSH_INCLUDE_DIRS})
-    set(RTRLIB_SRC ${RTRLIB_SRC} rtrlib/transport/ssh/ssh_transport.c)
-    set(RTRLIB_LINK ${RTRLIB_LINK} ${LIBSSH_LIBRARIES})
-    message(STATUS "libssh found, building librtr with SSH ${LibSSH_VERSION} support")
-else()
-    message(WARNING "libssh >=0.5.0 not found, building librtr without SSH support")
-endif(LIBSSH_FOUND AND NOT NOSSH)
+if (NOT DEFINED RTRLIB_TRANSPORT_SSH OR RTRLIB_TRANSPORT_SSH)
+    find_package(LibSSH 0.5.0 QUIET)
+
+    if(LIBSSH_FOUND)
+        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D LIBSSH_VERSION_MAJOR=${LibSSH_VERSION_MAJOR} -D LIBSSH_VERSION_MINOR=${LibSSH_VERSION_MINOR}")
+        set(RTRLIB_HAVE_LIBSSH 1)
+        include_directories(${LIBSSH_INCLUDE_DIRS})
+        set(RTRLIB_SRC ${RTRLIB_SRC} rtrlib/transport/ssh/ssh_transport.c)
+        set(RTRLIB_LINK ${RTRLIB_LINK} ${LIBSSH_LIBRARIES})
+        message(STATUS "libssh found, building librtr with SSH ${LibSSH_VERSION} support")
+    elseif(NOT LIBSSH_FOUND AND RTRLIB_TRANSPORT_SSH)
+        message(FATAL_ERROR "libssh >= 0.5.0 not found but ssh support was requested. Omit RTRLIB_TRANSPORT_SSH to build without ssh support.")
+    else()
+        message(WARNING "libssh >= 0.5.0 not found")
+    endif(LIBSSH_FOUND)
+endif(NOT DEFINED RTRLIB_TRANSPORT_SSH OR RTRLIB_TRANSPORT_SSH)
 
 #doxygen target
 find_package(Doxygen)
@@ -92,8 +111,8 @@
 
 #install lib
 set (RTRLIB_VERSION_MAJOR 0)
-set (RTRLIB_VERSION_MINOR 6)
-set (RTRLIB_VERSION_PATCH 3)
+set (RTRLIB_VERSION_MINOR 7)
+set (RTRLIB_VERSION_PATCH 0)
 CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/rtrlib/rtrlib.h.cmake ${CMAKE_SOURCE_DIR}/rtrlib/rtrlib.h)
 set(LIBRARY_VERSION ${RTRLIB_VERSION_MAJOR}.${RTRLIB_VERSION_MINOR}.${RTRLIB_VERSION_PATCH})
 set(LIBRARY_SOVERSION ${RTRLIB_VERSION_MAJOR})
@@ -118,9 +137,9 @@
 endforeach()
 
 #pkgconfig file
-if(LIBSSH_FOUND)
+if(RTRLIB_TRANSPORT_SSH)
     set (PKG_CONFIG_REQUIRES "libssh >= 0.5.0")
-endif(LIBSSH_FOUND)
+endif(RTRLIB_TRANSPORT_SSH)
 
 # '#include <rtrlib/rtrlib.h>' includes the "rtrlib/"
 set (PKG_CONFIG_LIBDIR "\${prefix}/${CMAKE_INSTALL_LIBDIR}")
