=== debian/changelog ===
librtr (0.7.0-1) unstable; urgency=medium

  [ Samuel Henrique ]
  * Team upload.
  * Add salsa-ci.yml.

  [ Debian Janitor ]
  * Set debhelper-compat version in Build-Depends.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

  [ Francisco Vilmar Cardoso Ruviaro ]
  * New upstream version 0.7.0.
  * Bump DH level to 13.
  * Bump Standards-Version to 4.5.1.
  * debian/control:
      - Add 'Rules-Requires-Root: no'.
      - Add pkg-config as build dependency.
  * debian/copyright: update upstream and packaging copyright.
  * debian/p/Use-FindPkgConfig-to-search-for-libssh-availability.patch: add.
    Thanks to Marcel Röthke <marcel.roethke@haw-hamburg.de>. (Closes: #975174)
  * debian/rules: drop DEB_LDFLAGS_MAINT_APPEND -Wl,--as-needed,
    because this is default behavior in bullseye toolchain.

 -- Francisco Vilmar Cardoso Ruviaro <francisco.ruviaro@riseup.net>  Sat, 16 Jan 2021 16:06:05 +0000
