=== debian/control ===
--- 
+++ 
@@ -5,10 +5,12 @@
 Uploaders: Lukas Schwaighofer <lukas@schwaighofer.name>
 Build-Depends:
  cmake,
- debhelper (>= 11),
+ debhelper-compat (= 13),
  doxygen,
  libssh-dev,
-Standards-Version: 4.2.1
+ pkg-config
+Standards-Version: 4.5.1
+Rules-Requires-Root: no
 Homepage: https://rtrlib.realmv6.org/
 Vcs-Browser: https://salsa.debian.org/pkg-security-team/librtr
 Vcs-Git: https://salsa.debian.org/pkg-security-team/librtr.git
