## librtr 0.8.0

=== debian/changelog ===
librtr (0.8.0-1) unstable; urgency=medium

  * New upstream version 0.8.0.
  * Update Standards-Version, no changes necessary.
  * Refresh patches, drop those merged upstream.
  * Add patch to disable full paths in Doxygen documentation.

 -- Lukas Schwaighofer <lukas@schwaighofer.name>  Sat, 11 Sep 2021 16:43:15 +0200
