=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
  doxygen,
  libssh-dev,
  pkg-config
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Homepage: https://rtrlib.realmv6.org/
 Vcs-Browser: https://salsa.debian.org/pkg-security-team/librtr
