=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%librtr-$1.tar.gz%" \
   https://github.com/rtrlib/rtrlib/releases \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian
